searchNodes=[{"doc":"GrpcMock is library for easy gRPC server mocking to be used with grpc-elixir library . Concurrency Unlike mox , GrpcMock is not thread-safe and cannot be used in concurrent tests. Example As an example, imagine that your application is using a remote calculator, with API defined in .proto file like this: service Calculator { rpc Add ( AddRequest ) returns ( AddResponse ) ; rpc Mult ( MultRequest ) returns ( MultResponse ) ; } If you want to mock the calculator gRPC calls during tests, the first step is to define the mock, usually in your test_helper.exs : GrpcMock . defmock ( CalcMock , for : Calculator ) Now in your tests, you can define expectations and verify them: use ExUnit.Case test &quot;invokes add and mult&quot; do # Start the gRPC server Server . start ( CalcMock , 50_051 ) # Connect to the serrver { :ok , channel } = GRPC.Stub . connect ( &quot;localhost:50051&quot; ) CalcMock |&gt; GrpcMock . expect ( :add , fn req , _ -&gt; AddResponse . new ( sum : req . x + req . y ) end ) |&gt; GrpcMock . expect ( :mult , fn req , _ -&gt; AddResponse . new ( sum : req . x * req . y ) end ) request = AddRequest . new ( x : 2 , y : 3 ) assert { :ok , reply } = channel |&gt; Stub . add ( request ) assert reply . sum == 5 request = MultRequest . new ( x : 2 , y : 3 ) assert { :ok , reply } = channel |&gt; Stub . mult ( request ) assert reply . sum == 6 GrpcMock . verify! ( CalcMock ) end","ref":"GrpcMock.html","title":"GrpcMock","type":"module"},{"doc":"Define mock in runtime based on specificatin on pb.ex file Example GrpcMock . defmock ( CalcMock , for : Calculator )","ref":"GrpcMock.html#defmock/2","title":"GrpcMock.defmock/2","type":"function"},{"doc":"Expect the name operation to be called n times. Examples If code_or_value is a function, it will be invoked as stub body. To expect add to be called five times: expect ( MyMock , :add , 5 , fn request , stream -&gt; ... end ) If code_or_value is anything other than a function, it will be stub return value. To expect add to be called once: expect ( CalcMock , :add , AddResponse . new ( sum : 12 ) end ) expect/4 can be invoked multiple times for the same name , allowing different behaviours on each invocation.","ref":"GrpcMock.html#expect/4","title":"GrpcMock.expect/4","type":"function"},{"doc":"Simmilar to expect/4 but there can be only one stubbed function. Number of expected invocations cannot be defined. Example If code_or_value is a function, it will be invoked as stub body. stub ( CalcMock , :add , fn ( request , _ ) -&gt; ... end ) If code_or_value is anything other than a function, it will be stub return value. stub ( CalcMock , :add , AddResponse . new ( sum : 12 ) end )","ref":"GrpcMock.html#stub/3","title":"GrpcMock.stub/3","type":"function"},{"doc":"Verify that all operations for the specified mock are called expected number of times and remove all expectations for it.","ref":"GrpcMock.html#verify!/1","title":"GrpcMock.verify!/1","type":"function"},{"doc":"","ref":"GrpcMock.UnexpectedCallError.html","title":"GrpcMock.UnexpectedCallError","type":"exception"},{"doc":"","ref":"GrpcMock.VerificationError.html","title":"GrpcMock.VerificationError","type":"exception"}]